Index: issm/trunk-jpl/src/c/classes/Inputs/Inputs.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Inputs/Inputs.cpp	(revision 18520)
+++ issm/trunk-jpl/src/c/classes/Inputs/Inputs.cpp	(revision 18521)
@@ -38,5 +38,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		input=dynamic_cast<Input*>(*object);
+		input=xDynamicCast<Input*>(*object);
 		if (input->InstanceEnum()==enum_type){
 			found=true;
@@ -65,5 +65,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		input=dynamic_cast<Input*>(*object);
+		input=xDynamicCast<Input*>(*object);
 		if (input->InstanceEnum()==enum_type){
 			found=true;
@@ -92,5 +92,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		input=dynamic_cast<Input*>(*object); 
+		input=xDynamicCast<Input*>(*object); 
 		if (input->InstanceEnum()==enum_type){
 			found=true;
@@ -119,5 +119,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		input=dynamic_cast<Input*>(*object);
+		input=xDynamicCast<Input*>(*object);
 		if (input->InstanceEnum()==enum_type){
 			found=true;
@@ -150,5 +150,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		input=dynamic_cast<Input*>(*object);
+		input=xDynamicCast<Input*>(*object);
 
 		if (input->InstanceEnum()==in_input->InstanceEnum()){
@@ -171,5 +171,5 @@
 	/*Delete existing input of newenumtype if it exists*/
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
-		input=dynamic_cast<Input*>(*object);
+		input=xDynamicCast<Input*>(*object);
 
 		if (input->InstanceEnum()==newenumtype){
@@ -182,5 +182,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		input=dynamic_cast<Input*>(*object);
+		input=xDynamicCast<Input*>(*object);
 
 		if (input->InstanceEnum()==oldenumtype){
@@ -194,5 +194,5 @@
 
 	/*Find x and y inputs: */
-	Input* constrain_input=dynamic_cast<Input*>(this->GetInput(constrain_enum));
+	Input* constrain_input=xDynamicCast<Input*>(this->GetInput(constrain_enum));
 
 	/*some checks: */
@@ -209,5 +209,5 @@
 
 	/*Get input*/
-	Input* input=dynamic_cast<Input*>(this->GetInput(enumtype));
+	Input* input=xDynamicCast<Input*>(this->GetInput(enumtype));
 
 	/*Apply ContrainMin: */
@@ -229,5 +229,5 @@
 
 	/*Get input*/
-	Input* input=dynamic_cast<Input*>(this->GetInput(enumtype));
+	Input* input=xDynamicCast<Input*>(this->GetInput(enumtype));
 
 	/*Apply ContrainMin: */
@@ -249,5 +249,5 @@
 
 	/*Get input*/
-	Input* input=dynamic_cast<Input*>(this->GetInput(enumtype));
+	Input* input=xDynamicCast<Input*>(this->GetInput(enumtype));
 
 	/*Apply ContrainMin: */
@@ -269,5 +269,5 @@
 
 	/*Get input*/
-	Input* input=dynamic_cast<Input*>(this->GetInput(enumtype));
+	Input* input=xDynamicCast<Input*>(this->GetInput(enumtype));
 
 	/*Apply ContrainMin: */
@@ -289,5 +289,5 @@
 
 	/*Get input*/
-	Input* input=dynamic_cast<Input*>(this->GetInput(enumtype));
+	Input* input=xDynamicCast<Input*>(this->GetInput(enumtype));
 
 	/*Apply ContrainMin: */
@@ -310,5 +310,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		input=dynamic_cast<Input*>(*object);
+		input=xDynamicCast<Input*>(*object);
 
 		if (input->InstanceEnum()==enum_name){
@@ -326,5 +326,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		input=dynamic_cast<Input*>(*object);
+		input=xDynamicCast<Input*>(*object);
 
 		if (input->InstanceEnum()==enum_type){
@@ -341,7 +341,7 @@
 
 	/*Make a copy of the original input: */
-	Input* original=dynamic_cast<Input*>(this->GetInput(original_enum));
+	Input* original=xDynamicCast<Input*>(this->GetInput(original_enum));
 	if(!original)_error_("could not find input with enum: " << EnumToStringx(original_enum)); 
-	Input* copy=dynamic_cast<Input*>(original->copy());
+	Input* copy=xDynamicCast<Input*>(original->copy());
 
 	/*Change copy enum to reinitialized_enum: */
@@ -349,5 +349,5 @@
 
 	/*Add copy into inputs, it will wipe off the one already there: */
-	this->AddInput(dynamic_cast<Input*>(copy));
+	this->AddInput(xDynamicCast<Input*>(copy));
 }
 /*}}}*/
@@ -366,5 +366,5 @@
 
 		/*Create new input*/
-		inputin=dynamic_cast<Input*>(*object);
+		inputin=xDynamicCast<Input*>(*object);
 		inputout=inputin->SpawnTriaInput(index1,index2,index3);
 
@@ -391,5 +391,5 @@
 
 		/*Create new input*/
-		inputin=dynamic_cast<Input*>(*object);
+		inputin=xDynamicCast<Input*>(*object);
 		inputout=inputin->SpawnSegInput(index1,index2);
 
@@ -405,6 +405,6 @@
 
 	/*Find x and y inputs: */
-	Input* xinput=dynamic_cast<Input*>(this->GetInput(inputx_enum));
-	Input* yinput=dynamic_cast<Input*>(this->GetInput(inputy_enum));
+	Input* xinput=xDynamicCast<Input*>(this->GetInput(inputx_enum));
+	Input* yinput=xDynamicCast<Input*>(this->GetInput(inputy_enum));
 
 	/*some checks: */
@@ -423,5 +423,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		input=dynamic_cast<Input*>(*object);
+		input=xDynamicCast<Input*>(*object);
 		input->Configure(parameters);
 
Index: issm/trunk-jpl/src/c/classes/IoModel.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/IoModel.cpp	(revision 18520)
+++ issm/trunk-jpl/src/c/classes/IoModel.cpp	(revision 18521)
@@ -259,8 +259,8 @@
 
 	/*Find constant*/
-	Param* param=dynamic_cast<Param*>(this->constants->FindParamObject(constant_enum));
+	Param* param=xDynamicCast<Param*>(this->constants->FindParamObject(constant_enum));
 	if(!param) _error_("Constant " << EnumToStringx(constant_enum) << " not found in iomodel");
 
-	return dynamic_cast<Param*>(param->copy());
+	return xDynamicCast<Param*>(param->copy());
 }
 /*}}}*/
@@ -1455,5 +1455,5 @@
 
 	for(int i=0;i<elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
+		Element* element=xDynamicCast<Element*>(elements->GetObjectByOffset(i));
 		if(!doublearray) element->AddInput(vector_enum,&default_value,P0Enum); 
 		else             element->InputCreate(doublearray,this,M,N,vector_layout,vector_enum,code);//we need i to index into elements.
@@ -1485,5 +1485,5 @@
 			this->FetchData(&boolean,vector_enum);
 			for(i=0;i<elements->Size();i++){
-				Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
+				Element* element=xDynamicCast<Element*>(elements->GetObjectByOffset(i));
 				element->InputUpdateFromConstant(boolean,vector_enum);
 			}
@@ -1492,5 +1492,5 @@
 			this->FetchData(&integer,vector_enum);
 			for(i=0;i<elements->Size();i++){
-				Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
+				Element* element=xDynamicCast<Element*>(elements->GetObjectByOffset(i));
 				element->InputUpdateFromConstant(integer,vector_enum);
 			}
@@ -1499,5 +1499,5 @@
 			this->FetchData(&scalar,vector_enum);
 			for(i=0;i<elements->Size();i++){
-				Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
+				Element* element=xDynamicCast<Element*>(elements->GetObjectByOffset(i));
 				element->InputUpdateFromConstant(scalar,vector_enum);
 			}
@@ -1507,5 +1507,5 @@
 			if(!doublearray) _error_(EnumToStringx(vector_enum)<<" not found in binary file");
 			for(i=0;i<elements->Size();i++){
-				Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
+				Element* element=xDynamicCast<Element*>(elements->GetObjectByOffset(i));
 				element->InputCreate(doublearray,this,M,N,vector_layout,vector_enum,code);//we need i to index into elements.
 			}
@@ -1515,5 +1515,5 @@
 			if(!doublearray) _error_(EnumToStringx(vector_enum)<<" not found in binary file");
 			for(i=0;i<elements->Size();i++){
-				Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
+				Element* element=xDynamicCast<Element*>(elements->GetObjectByOffset(i));
 				element->InputCreate(doublearray,this,M,N,vector_layout,vector_enum,code);//we need i to index into elements.
 			}
@@ -1523,5 +1523,5 @@
 			if(!doublearray) _error_(EnumToStringx(vector_enum)<<" not found in binary file");
 			for(i=0;i<elements->Size();i++){
-				Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
+				Element* element=xDynamicCast<Element*>(elements->GetObjectByOffset(i));
 				element->InputCreate(doublearray,this,M,N,vector_layout,vector_enum,code);//we need i to index into elements.
 			}
Index: issm/trunk-jpl/src/c/classes/Loads/Loads.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Loads/Loads.cpp	(revision 18520)
+++ issm/trunk-jpl/src/c/classes/Loads/Loads.cpp	(revision 18521)
@@ -41,5 +41,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		load=dynamic_cast<Load*>(*object);
+		load=xDynamicCast<Load*>(*object);
 		load->Configure(elements,loads,nodes,vertices,materials,parameters);
 
@@ -55,5 +55,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		load=dynamic_cast<Load*>((*object));
+		load=xDynamicCast<Load*>((*object));
 		load->ResetHooks();
 
@@ -70,5 +70,5 @@
 	for(int i=0;i<this->Size();i++){
 
-		Load* load=dynamic_cast<Load*>(this->GetObjectByOffset(i));
+		Load* load=xDynamicCast<Load*>(this->GetObjectByOffset(i));
 		if (load->InAnalysis(analysis_type)){
 			if(load->IsPenalty()) ispenalty++;
@@ -95,5 +95,5 @@
 	for(int i=0;i<this->Size();i++){
 
-		Load* load=dynamic_cast<Load*>(this->GetObjectByOffset(i));
+		Load* load=xDynamicCast<Load*>(this->GetObjectByOffset(i));
 		if (load->InAnalysis(analysis_type)){
 			numnodes=load->GetNumberOfNodes();
@@ -132,5 +132,5 @@
 	for(int i=0;i<this->Size();i++){
 
-		Load* load=dynamic_cast<Load*>(this->GetObjectByOffset(i));
+		Load* load=xDynamicCast<Load*>(this->GetObjectByOffset(i));
 
 		/*Check that this load corresponds to our analysis currently being carried out: */
@@ -157,5 +157,5 @@
 	for(int i=0;i<this->Size();i++){
 
-		Load* load=dynamic_cast<Load*>(this->GetObjectByOffset(i));
+		Load* load=xDynamicCast<Load*>(this->GetObjectByOffset(i));
 
 		/*Check that this load corresponds to our analysis currently being carried out: */
@@ -173,5 +173,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		load=dynamic_cast<Load*>(*object);
+		load=xDynamicCast<Load*>(*object);
 		load->SetCurrentConfiguration(elements,loads,nodes,vertices,materials,parameters);
 
Index: issm/trunk-jpl/src/c/classes/Materials/Materials.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Materials/Materials.cpp	(revision 18520)
+++ issm/trunk-jpl/src/c/classes/Materials/Materials.cpp	(revision 18521)
@@ -37,5 +37,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		material=dynamic_cast<Material*>(*object);
+		material=xDynamicCast<Material*>(*object);
 		material->Configure(elements);
 
@@ -51,5 +51,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		material=dynamic_cast<Material*>((*object));
+		material=xDynamicCast<Material*>((*object));
 		material->ResetHooks();
 
Index: issm/trunk-jpl/src/c/classes/Nodes.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Nodes.cpp	(revision 18520)
+++ issm/trunk-jpl/src/c/classes/Nodes.cpp	(revision 18521)
@@ -49,5 +49,5 @@
 	/*Go through objects, and distribute dofs locally, from 0 to numberofdofsperobject*/
 	for(i=0;i<this->Size();i++){
-		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
+		Node* node=xDynamicCast<Node*>(this->GetObjectByOffset(i));
 
 		/*Check that this node corresponds to our analysis currently being carried out: */
@@ -72,5 +72,5 @@
 	for(i=0;i<this->Size();i++){
 		/*Check that this node corresponds to our analysis currently being carried out: */
-		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
+		Node* node=xDynamicCast<Node*>(this->GetObjectByOffset(i));
 		if (node->InAnalysis(analysis_type)){
 			node->OffsetDofs(dofcount,setenum);
@@ -89,5 +89,5 @@
 
 	for(i=0;i<this->Size();i++){
-		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
+		Node* node=xDynamicCast<Node*>(this->GetObjectByOffset(i));
 		if (node->InAnalysis(analysis_type)){
 			node->ShowTrueDofs(truedofs,maxdofspernode,setenum);//give maxdofspernode, column size, so that nodes can index into truedofs
@@ -99,5 +99,5 @@
 	/* Now every cpu knows the true dofs of everyone else that is not a clone*/
 	for(i=0;i<this->Size();i++){
-		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
+		Node* node=xDynamicCast<Node*>(this->GetObjectByOffset(i));
 		if (node->InAnalysis(analysis_type)){
 			node->UpdateCloneDofs(alltruedofs,maxdofspernode,setenum);
@@ -107,5 +107,5 @@
 	/*Update indexingupdateflag*/
 	for(i=0;i<this->Size();i++){
-		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
+		Node* node=xDynamicCast<Node*>(this->GetObjectByOffset(i));
 		if (node->InAnalysis(analysis_type)){
 			node->ReindexingDone();
@@ -148,5 +148,5 @@
 	for(i=0;i<this->Size();i++){
 
-		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
+		Node* node=xDynamicCast<Node*>(this->GetObjectByOffset(i));
 
 		/*Check that this node corresponds to our analysis currently being carried out: */
@@ -172,5 +172,5 @@
 	for(int i=0;i<this->Size();i++){
 
-		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
+		Node* node=xDynamicCast<Node*>(this->GetObjectByOffset(i));
 
 		/*Check that this node corresponds to our analysis currently being carried out: */
@@ -197,5 +197,5 @@
 	if(!sorted){
 		for(int i=0;i<this->Size();i++){
-			Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
+			Node* node=xDynamicCast<Node*>(this->GetObjectByOffset(i));
 			id=node->Id();
 			if(id>max)max=id;
@@ -207,5 +207,5 @@
 		}
 		else{
-			Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(this->Size()-1));
+			Node* node=xDynamicCast<Node*>(this->GetObjectByOffset(this->Size()-1));
 			max = node->Id();
 		}
@@ -238,5 +238,5 @@
 	for(int i=0;i<this->Size();i++){
 
-		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
+		Node* node=xDynamicCast<Node*>(this->GetObjectByOffset(i));
 
 		/*Check that this node corresponds to our analysis currently being carried out: */
@@ -262,5 +262,5 @@
 	/*Now go through all nodes, and get how many dofs they own, unless they are clone nodes: */
 	for(int i=0;i<this->Size();i++){
-		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
+		Node* node=xDynamicCast<Node*>(this->GetObjectByOffset(i));
 
 		/*Ok, this object is a node, ask it to plug values into partition: */
@@ -284,5 +284,5 @@
 	for(i=0;i<this->Size();i++){
 
-		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
+		Node* node=xDynamicCast<Node*>(this->GetObjectByOffset(i));
 
 		/*Check that this node corresponds to our analysis currently being carried out: */
@@ -316,5 +316,5 @@
 	for(int i=0;i<this->Size();i++){
 
-		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
+		Node* node=xDynamicCast<Node*>(this->GetObjectByOffset(i));
 
 		/*Check that this node corresponds to our analysis currently being carried out: */
@@ -335,5 +335,5 @@
 	for(int i=0;i<this->Size();i++){
 
-		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
+		Node* node=xDynamicCast<Node*>(this->GetObjectByOffset(i));
 
 		/*Check that this node corresponds to our analysis currently being carried out: */
Index: issm/trunk-jpl/src/c/classes/Options/Options.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Options/Options.cpp	(revision 18520)
+++ issm/trunk-jpl/src/c/classes/Options/Options.cpp	(revision 18521)
@@ -52,5 +52,5 @@
 	for(object=objects.begin();object<objects.end();object++){
 
-		option=dynamic_cast<Option*>(*object);
+		option=xDynamicCast<Option*>(*object);
 		if (!strcmp(option->Name(),name)){
 			_error_("Options \"" << name << "\" found multiple times");
@@ -73,5 +73,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		option=dynamic_cast<Option*>(*object);
+		option=xDynamicCast<Option*>(*object);
 		//option=(Option*)(*object); //C-like cast
 		/*There is a crash on some machines (Einar Olason) that needs to be fixed*/
Index: issm/trunk-jpl/src/c/classes/Options/Options.h
===================================================================
--- issm/trunk-jpl/src/c/classes/Options/Options.h	(revision 18520)
+++ issm/trunk-jpl/src/c/classes/Options/Options.h	(revision 18521)
@@ -26,5 +26,5 @@
 
 			/*Get option*/
-			GenericOption<OptionType>* genericoption=dynamic_cast<GenericOption<OptionType>*>(GetOption(name));
+			GenericOption<OptionType>* genericoption=xDynamicCast<GenericOption<OptionType>*>(GetOption(name));
 
 			/*If the pointer is not NULL, the option has been found*/
@@ -41,5 +41,5 @@
 
 			/*Get option*/
-			GenericOption<OptionType>* genericoption=dynamic_cast<GenericOption<OptionType>*>(GetOption(name));
+			GenericOption<OptionType>* genericoption=xDynamicCast<GenericOption<OptionType>*>(GetOption(name));
 
 			/*If the pointer is not NULL, the option has been found*/
@@ -57,5 +57,5 @@
 
 			/*Get option*/
-			GenericOption<OptionType>* genericoption=dynamic_cast<GenericOption<OptionType>*>(GetOption(name));
+			GenericOption<OptionType>* genericoption=xDynamicCast<GenericOption<OptionType>*>(GetOption(name));
 
 			/*If the pointer is not NULL, the option has been found*/
@@ -72,5 +72,5 @@
 
 			/*Get option*/
-			GenericOption<OptionType>* genericoption=dynamic_cast<GenericOption<OptionType>*>(GetOption(name));
+			GenericOption<OptionType>* genericoption=xDynamicCast<GenericOption<OptionType>*>(GetOption(name));
 
 			/*If the pointer is not NULL, the option has been found*/
@@ -92,5 +92,5 @@
 
 	/*Get option*/
-	GenericOption<char*>* genericoption=dynamic_cast<GenericOption<char*>*>(GetOption(name));
+	GenericOption<char*>* genericoption=xDynamicCast<GenericOption<char*>*>(GetOption(name));
 
 	/*If the pointer is not NULL, the option has been found*/
Index: issm/trunk-jpl/src/c/classes/Params/Parameters.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Params/Parameters.cpp	(revision 18520)
+++ issm/trunk-jpl/src/c/classes/Params/Parameters.cpp	(revision 18521)
@@ -57,5 +57,5 @@
 
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
-		param=dynamic_cast<Param*>(*object);
+		param=xDynamicCast<Param*>(*object);
 		if(param->InstanceEnum()==enum_type) return true;
 	}
@@ -70,5 +70,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		param=dynamic_cast<Param*>(*object);
+		param=xDynamicCast<Param*>(*object);
 		if(param->InstanceEnum()==enum_type){
 			param->GetParameterValue(pbool);
@@ -86,5 +86,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		param=dynamic_cast<Param*>(*object);
+		param=xDynamicCast<Param*>(*object);
 		if(param->InstanceEnum()==enum_type){
 			param->GetParameterValue(pinteger);
@@ -102,5 +102,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		param=dynamic_cast<Param*>(*object);
+		param=xDynamicCast<Param*>(*object);
 		if(param->InstanceEnum()==enum_type){
 			param->GetParameterValue(pscalar);
@@ -118,5 +118,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		param=dynamic_cast<Param*>(*object);
+		param=xDynamicCast<Param*>(*object);
 		if(param->InstanceEnum()==enum_type){
 			param->GetParameterValue(pscalar,time);
@@ -134,5 +134,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		param=dynamic_cast<Param*>(*object);
+		param=xDynamicCast<Param*>(*object);
 		if(param->InstanceEnum()==enum_type){
 			param->GetParameterValue(pstring);
@@ -151,5 +151,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		param=dynamic_cast<Param*>(*object);
+		param=xDynamicCast<Param*>(*object);
 		if(param->InstanceEnum()==enum_type){
 			param->GetParameterValue(pstringarray,pM);
@@ -168,5 +168,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		param=dynamic_cast<Param*>(*object);
+		param=xDynamicCast<Param*>(*object);
 		if(param->InstanceEnum()==enum_type){
 			param->GetParameterValue(pintarray,pM);
@@ -185,5 +185,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		param=dynamic_cast<Param*>(*object);
+		param=xDynamicCast<Param*>(*object);
 		if(param->InstanceEnum()==enum_type){
 			param->GetParameterValue(pintarray,pM,pN);
@@ -202,5 +202,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		param=dynamic_cast<Param*>(*object);
+		param=xDynamicCast<Param*>(*object);
 		if(param->InstanceEnum()==enum_type){
 			param->GetParameterValue(pIssmDoublearray,pM);
@@ -219,5 +219,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		param=dynamic_cast<Param*>(*object);
+		param=xDynamicCast<Param*>(*object);
 		if(param->InstanceEnum()==enum_type){
 			param->GetParameterValue(pIssmDoublearray,pM,pN);
@@ -236,5 +236,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		param=dynamic_cast<Param*>(*object);
+		param=xDynamicCast<Param*>(*object);
 		if(param->InstanceEnum()==enum_type){
 			param->GetParameterValue(parray,pM,pmdims_array,pndims_array);
@@ -252,5 +252,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		param=dynamic_cast<Param*>(*object);
+		param=xDynamicCast<Param*>(*object);
 		if(param->InstanceEnum()==enum_type){
 			param->GetParameterValue(pvec);
@@ -269,5 +269,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		param=dynamic_cast<Param*>(*object);
+		param=xDynamicCast<Param*>(*object);
 		if(param->InstanceEnum()==enum_type){
 			param->GetParameterValue(pmat);
@@ -286,5 +286,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		param=dynamic_cast<Param*>(*object);
+		param=xDynamicCast<Param*>(*object);
 		if(param->InstanceEnum()==enum_type){
 			param->GetParameterValue(pfid);
@@ -303,5 +303,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		param=dynamic_cast<Param*>(*object);
+		param=xDynamicCast<Param*>(*object);
 		if(param->InstanceEnum()==enum_type){
 			param->GetParameterValue(pdataset);
@@ -318,5 +318,5 @@
 
 	/*first, figure out if the param has already been created: */
-	param=dynamic_cast<Param*>(this->FindParamObject(enum_type));
+	param=xDynamicCast<Param*>(this->FindParamObject(enum_type));
 
 	if(param) param->SetValue(boolean); //already exists, just set it.
@@ -329,5 +329,5 @@
 
 	/*first, figure out if the param has already been created: */
-	param=dynamic_cast<Param*>(this->FindParamObject(enum_type));
+	param=xDynamicCast<Param*>(this->FindParamObject(enum_type));
 
 	if(param) param->SetValue(integer); //already exists, just set it.
@@ -340,5 +340,5 @@
 
 	/*first, figure out if the param has already been created: */
-	param=dynamic_cast<Param*>(this->FindParamObject(enum_type));
+	param=xDynamicCast<Param*>(this->FindParamObject(enum_type));
 
 	if(param) param->SetValue(scalar); //already exists, just set it.
@@ -351,5 +351,5 @@
 
 	/*first, figure out if the param has already been created: */
-	param=dynamic_cast<Param*>(this->FindParamObject(enum_type));
+	param=xDynamicCast<Param*>(this->FindParamObject(enum_type));
 
 	if(param) param->SetValue(string); //already exists, just set it.
@@ -362,5 +362,5 @@
 
 	/*first, figure out if the param has already been created: */
-	param=dynamic_cast<Param*>(this->FindParamObject(enum_type));
+	param=xDynamicCast<Param*>(this->FindParamObject(enum_type));
 
 	if(param) param->SetValue(stringarray,M); //already exists, just set it.
@@ -373,5 +373,5 @@
 
 	/*first, figure out if the param has already been created: */
-	param=dynamic_cast<Param*>(this->FindParamObject(enum_type));
+	param=xDynamicCast<Param*>(this->FindParamObject(enum_type));
 
 	if(param) param->SetValue(IssmDoublearray,M); //already exists, just set it.
@@ -384,5 +384,5 @@
 
 	/*first, figure out if the param has already been created: */
-	param=dynamic_cast<Param*>(this->FindParamObject(enum_type));
+	param=xDynamicCast<Param*>(this->FindParamObject(enum_type));
 
 	if(param) param->SetValue(IssmDoublearray,M,N); //already exists, just set it.
@@ -395,5 +395,5 @@
 
 	/*first, figure out if the param has already been created: */
-	param=dynamic_cast<Param*>(this->FindParamObject(enum_type));
+	param=xDynamicCast<Param*>(this->FindParamObject(enum_type));
 
 	if(param) param->SetValue(intarray,M); //already exists, just set it.
@@ -406,5 +406,5 @@
 
 	/*first, figure out if the param has already been created: */
-	param=dynamic_cast<Param*>(this->FindParamObject(enum_type));
+	param=xDynamicCast<Param*>(this->FindParamObject(enum_type));
 
 	if(param) param->SetValue(intarray,M,N); //already exists, just set it.
@@ -417,5 +417,5 @@
 
 	/*first, figure out if the param has already been created: */
-	param=dynamic_cast<Param*>(this->FindParamObject(enum_type));
+	param=xDynamicCast<Param*>(this->FindParamObject(enum_type));
 
 	if(param) param->SetValue(vector); //already exists, just set it.
@@ -428,5 +428,5 @@
 
 	/*first, figure out if the param has already been created: */
-	param=dynamic_cast<Param*>(this->FindParamObject(enum_type));
+	param=xDynamicCast<Param*>(this->FindParamObject(enum_type));
 
 	if(param) param->SetValue(matrix); //already exists, just set it.
@@ -439,5 +439,5 @@
 
 	/*first, figure out if the param has already been created: */
-	param=dynamic_cast<Param*>(this->FindParamObject(enum_type));
+	param=xDynamicCast<Param*>(this->FindParamObject(enum_type));
 
 	if(param) param->SetValue(fid); //already exists, just set it.
@@ -450,5 +450,5 @@
 
 	/*first, figure out if the param has already been created: */
-	param=dynamic_cast<Param*>(this->FindParamObject(enum_type));
+	param=xDynamicCast<Param*>(this->FindParamObject(enum_type));
 
 	if(param) param->SetValue(dataset); //already exists, just set it.
@@ -464,5 +464,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		param=dynamic_cast<Param*>(*object);
+		param=xDynamicCast<Param*>(*object);
 		if(param->InstanceEnum()==enum_type){
 			return (*object);
Index: issm/trunk-jpl/src/c/classes/Vertices.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Vertices.cpp	(revision 18520)
+++ issm/trunk-jpl/src/c/classes/Vertices.cpp	(revision 18521)
@@ -52,5 +52,5 @@
 	/*Go through objects, and distribute pids locally, from 0 to numberofpidsperobject*/
 	for (i=0;i<this->Size();i++){
-		Vertex* vertex=dynamic_cast<Vertex*>(this->GetObjectByOffset(i));
+		Vertex* vertex=xDynamicCast<Vertex*>(this->GetObjectByOffset(i));
 		vertex->DistributePids(&pidcount);
 	}
@@ -72,5 +72,5 @@
 	}
 	for (i=0;i<this->Size();i++){
-		Vertex* vertex=dynamic_cast<Vertex*>(this->GetObjectByOffset(i));
+		Vertex* vertex=xDynamicCast<Vertex*>(this->GetObjectByOffset(i));
 		vertex->OffsetPids(pidcount);
 	}
@@ -82,5 +82,5 @@
 	alltruepids=xNewZeroInit<int>(numberofobjects);
 	for (i=0;i<this->Size();i++){
-		Vertex* vertex=dynamic_cast<Vertex*>(this->GetObjectByOffset(i));
+		Vertex* vertex=xDynamicCast<Vertex*>(this->GetObjectByOffset(i));
 		vertex->ShowTruePids(truepids);
 	}
@@ -89,5 +89,5 @@
 	/* Now every cpu knows the true pids of everyone else that is not a clone*/
 	for(i=0;i<this->Size();i++){
-		Vertex* vertex=dynamic_cast<Vertex*>(this->GetObjectByOffset(i));
+		Vertex* vertex=xDynamicCast<Vertex*>(this->GetObjectByOffset(i));
 		vertex->UpdateClonePids(alltruepids);
 	}
@@ -128,5 +128,5 @@
 	for(i=0;i<this->Size();i++){
 		/*For this object, decide whether it is a clone: */
-		Vertex* vertex=dynamic_cast<Vertex*>(this->GetObjectByOffset(i));
+		Vertex* vertex=xDynamicCast<Vertex*>(this->GetObjectByOffset(i));
 		vertex->SetClone(minranks);
 	}
@@ -145,5 +145,5 @@
 
 	for(i=0;i<this->Size();i++){
-		Vertex* vertex=dynamic_cast<Vertex*>(this->GetObjectByOffset(i));
+		Vertex* vertex=xDynamicCast<Vertex*>(this->GetObjectByOffset(i));
 		sid=vertex->Sid();
 		if (sid>max_sid)max_sid=sid;
@@ -172,5 +172,5 @@
 	for(int i=0;i<this->Size();i++){
 		/*Plug rank into ranks, according to id: */
-		Vertex* vertex=dynamic_cast<Vertex*>(this->GetObjectByOffset(i));
+		Vertex* vertex=xDynamicCast<Vertex*>(this->GetObjectByOffset(i));
 		sid=vertex->Sid();
 		ranks[sid]=my_rank; 
@@ -202,5 +202,5 @@
 
 		/*let vertex fill matrix: */
-		Vertex* vertex=dynamic_cast<Vertex*>(this->GetObjectByOffset(i));
+		Vertex* vertex=xDynamicCast<Vertex*>(this->GetObjectByOffset(i));
 		vertex->ToXYZ(xyz);
 	}
Index: issm/trunk-jpl/src/c/classes/gauss/GaussPenta.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/gauss/GaussPenta.cpp	(revision 18520)
+++ issm/trunk-jpl/src/c/classes/gauss/GaussPenta.cpp	(revision 18521)
@@ -8,4 +8,5 @@
 #include "../../shared/Exceptions/exceptions.h"
 #include "../../shared/MemOps/MemOps.h"
+#include "../../shared/Numerics/recast.h"
 #include "../../shared/Enum/Enum.h"
 #include "../../shared/Numerics/GaussPoints.h"
@@ -750,5 +751,5 @@
 
 	_assert_(gauss->Enum()==GaussTriaEnum);
-	GaussTria* gauss_tria = dynamic_cast<GaussTria*>(gauss);
+	GaussTria* gauss_tria = xDynamicCast<GaussTria*>(gauss);
 
 	gauss_tria->coord1=this->coord1;
